-- Default settings
defaultSettings = {
    invert = false;
	sell = true;
	give = true;
	valar = true;
	buy = true;
	search = true;
	exchange = true;
	group = false;
	kinship = false;
	craft = false;
	chelp = false;
	mp = false;
	links = false;
	higb = false;
	exfilter = false;
	infilter = false;
	exfpattern = "";
	infpattern = "";
	blstate = false;
	wlstate = false;
	blacklist = "";
	whitelist = "";
	plng = PLang;
};
settings = {};
DeepTableCopy(defaultSettings, settings);
_G.sset = 0;

--## Functions for Load and Save Data ##--
function SaveSettings(silent,server)
	local DSV = "";
	-- Workaround for Turbine localization bug
	local saveData = ExportTable(settings);
	if (server == true) then DSV = Turbine.DataScope.Server; else DSV = Turbine.DataScope.Character; end
	Turbine.PluginData.Save(DSV, "WCFilter", saveData, function() if (server == true) then sset = 1; UpdateOptionsPanel(); DoCallbacks(optionsPanel, SChng); end; end);
	DeepTableCopy(settings, settings);
	if (silent == false) then Turbine.Shell.WriteLine("<rgb=#DAA5DA>WCF-Data "..WCFLangData.dstxt..".</rgb>"); end;
end

function LoadSettings(silent,server)
	local DSV = "";
	local checks = 0;
	if (server == true) then DSV = Turbine.DataScope.Server; else DSV = Turbine.DataScope.Character; end
	Turbine.PluginData.Load(DSV, "WCFilter", function(loadedData)
		if (loadedData) then
			checks = 1;
			-- Workaround for Turbine localization bug
			loadedData = ImportTable(loadedData);
			DeepTableCopy(loadedData, settings)
			if (server == true) then sset = 1;  end;
			UpdateOptionsPanel();
			DoCallbacks(optionsPanel, SChng);
		end
	end);
	if (silent == false) then Turbine.Shell.WriteLine("<rgb=#DAA5DA>WCF-Data "..WCFLangData.dltxt..".</rgb>"); end;
	if (checks == 1) and (server == true) then SaveSettings(true,false) end;
end

LoadSettings(true,true);

optionsPanel = Turbine.UI.Control();
--## Function for drawing the options panel ##--
function UpdateOptionsPanel()
	local SChng = "SettingsChanged"
	local font = Turbine.UI.Lotro.Font.Verdana12;
	local fontb = Turbine.UI.Lotro.Font.Verdana14;
	local alignML = Turbine.UI.ContentAlignment.MiddleLeft;
	local alignMC = Turbine.UI.ContentAlignment.MiddleCenter;
	local alignLC = Turbine.UI.ContentAlignment.LeftCenter;
	local alignTL = Turbine.UI.ContentAlignment.TopLeft;
	local left, top, width = 10, 10, 300;
	local columnWidth = math.floor(width / 2);
	local spaces = "  "
	local col1 = "<b><rgb=#20A5DA>"
	local col2 = "<b><rgb=#DAA5DA>WCF-Data: "
	local col0 = "</rgb></b>"

	local function add_horizontal_line(top,double)
		local line = Turbine.UI.Control();
		local lheight = 1
		line:SetParent(optionsPanel);
		if (double == true) then
			top = top + 28
			lheight = 3
		else
			top = top + 24
		end;
		line:SetPosition(0, top);
		line:SetSize(width + (left * 2), lheight);
		line:SetBackColor(Turbine.UI.Color(41/255, 48/255, 72/255));
		return top + 8;
	end

	label = Turbine.UI.Label();
	label:SetParent(optionsPanel);
	label:SetPosition(left, top);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor( Turbine.UI.Color(0.2, 0.2, 1));
	label:SetForeColor( Turbine.UI.Color(0, 1, 0));
	label:SetText(WCFLangData.mainlabel);
	label:SetTextAlignment(alignMC);

	-- Invert --
	top = add_horizontal_line(top, true);
	if (not optionsPanel.invert) then
		optionsPanel.invert = Turbine.UI.Lotro.CheckBox();
		optionsPanel.invert:SetParent(optionsPanel);
		optionsPanel.invert:SetSize(width, 18);
		optionsPanel.invert:SetPosition(left, top + 1);
		optionsPanel.invert:SetFont(font);
		optionsPanel.invert:SetMarkupEnabled(true);
		optionsPanel.invert:SetBackColor( Turbine.UI.Color(0.2, 0.2, 0.2));
		optionsPanel.invert:SetCheckAlignment(alignML);
		optionsPanel.invert:SetText(spaces..col1..WCFLangData.inverttxt..col0);
		optionsPanel.invert.CheckedChanged = function(box)
			settings.invert = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Sell --
	top = add_horizontal_line(top, true);
	if (not optionsPanel.sell) then
		optionsPanel.sell = Turbine.UI.Lotro.CheckBox();
		optionsPanel.sell:SetParent(optionsPanel);
		optionsPanel.sell:SetSize(width, 18);
		optionsPanel.sell:SetPosition(left, top);
		optionsPanel.sell:SetFont(font);
		optionsPanel.sell:SetCheckAlignment(alignML);
		optionsPanel.sell:SetText(spaces..WCFLangData.sell);
		optionsPanel.sell.CheckedChanged = function(box)
			settings.sell = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Give --
	top = add_horizontal_line(top);
	if (not optionsPanel.give) then
		optionsPanel.give = Turbine.UI.Lotro.CheckBox();
		optionsPanel.give:SetParent(optionsPanel);
		optionsPanel.give:SetSize(width, 16);
		optionsPanel.give:SetPosition(left, top);
		optionsPanel.give:SetFont(font);
		optionsPanel.give:SetCheckAlignment(alignML);
		optionsPanel.give:SetText(spaces..WCFLangData.give);
		optionsPanel.give.CheckedChanged = function(box)
			settings.give = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Valar --
	top = add_horizontal_line(top);	
	if (not optionsPanel.valar) then
		optionsPanel.valar = Turbine.UI.Lotro.CheckBox();
		optionsPanel.valar:SetParent(optionsPanel);
		optionsPanel.valar:SetSize(width, 16);
		optionsPanel.valar:SetPosition(left, top);
		optionsPanel.valar:SetFont(font);
		optionsPanel.valar:SetCheckAlignment(alignML);
		optionsPanel.valar:SetText(spaces..WCFLangData.valartxt);
		optionsPanel.valar.CheckedChanged = function(box)
			settings.valar = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Buy --
	top = add_horizontal_line(top);	
	if (not optionsPanel.buy) then
		optionsPanel.buy = Turbine.UI.Lotro.CheckBox();
		optionsPanel.buy:SetParent(optionsPanel);
		optionsPanel.buy:SetSize(width, 16);
		optionsPanel.buy:SetPosition(left, top);
		optionsPanel.buy:SetFont(font);
		optionsPanel.buy:SetCheckAlignment(alignML);
		optionsPanel.buy:SetText(spaces..WCFLangData.buy);
		optionsPanel.buy.CheckedChanged = function(box)
			settings.buy = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Search --
	top = add_horizontal_line(top);	
	if (not optionsPanel.search) then
		optionsPanel.search = Turbine.UI.Lotro.CheckBox();
		optionsPanel.search:SetParent(optionsPanel);
		optionsPanel.search:SetSize(width, 16);
		optionsPanel.search:SetPosition(left, top);
		optionsPanel.search:SetFont(font);
		optionsPanel.search:SetCheckAlignment(alignML);
		optionsPanel.search:SetText(spaces..WCFLangData.search);
		optionsPanel.search.CheckedChanged = function(box)
			settings.search = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Exchange --
	top = add_horizontal_line(top);
	if (not optionsPanel.exchange) then	
		optionsPanel.exchange = Turbine.UI.Lotro.CheckBox();
		optionsPanel.exchange:SetParent(optionsPanel);
		optionsPanel.exchange:SetSize(width, 16);
		optionsPanel.exchange:SetPosition(left, top);
		optionsPanel.exchange:SetFont(font);
		optionsPanel.exchange:SetCheckAlignment(alignML);
		optionsPanel.exchange:SetText(spaces..WCFLangData.exchange);
		optionsPanel.exchange.CheckedChanged = function(box)
			settings.exchange = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Group --
	top = add_horizontal_line(top);
	if (not optionsPanel.group) then	
		optionsPanel.group = Turbine.UI.Lotro.CheckBox();
		optionsPanel.group:SetParent(optionsPanel);
		optionsPanel.group:SetSize(width, 16);
		optionsPanel.group:SetPosition(left, top);
		optionsPanel.group:SetFont(font);
		optionsPanel.group:SetCheckAlignment(alignML);
		optionsPanel.group:SetText(spaces..WCFLangData.grouptxt);
		optionsPanel.group.CheckedChanged = function(box)
			settings.group = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Kinship --
	top = add_horizontal_line(top);
	if (not optionsPanel.kinship) then	
		optionsPanel.kinship = Turbine.UI.Lotro.CheckBox();
		optionsPanel.kinship:SetParent(optionsPanel);
		optionsPanel.kinship:SetSize(width, 16);
		optionsPanel.kinship:SetPosition(left, top);
		optionsPanel.kinship:SetFont(font);
		optionsPanel.kinship:SetCheckAlignment(alignML);
		optionsPanel.kinship:SetText(spaces..WCFLangData.kinship);
		optionsPanel.kinship.CheckedChanged = function(box)
			settings.kinship = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Craft --
	top = add_horizontal_line(top);
	if (not optionsPanel.craft) then	
		optionsPanel.craft = Turbine.UI.Lotro.CheckBox();
		optionsPanel.craft:SetParent(optionsPanel);
		optionsPanel.craft:SetSize(width, 16);
		optionsPanel.craft:SetPosition(left, top);
		optionsPanel.craft:SetFont(font);
		optionsPanel.craft:SetCheckAlignment(alignML);
		optionsPanel.craft:SetText(spaces..WCFLangData.craft);
		optionsPanel.craft.CheckedChanged = function(box)
			settings.craft = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Help --
	top = add_horizontal_line(top);
	if (not optionsPanel.chelp) then	
		optionsPanel.chelp = Turbine.UI.Lotro.CheckBox();
		optionsPanel.chelp:SetParent(optionsPanel);
		optionsPanel.chelp:SetSize(width, 16);
		optionsPanel.chelp:SetPosition(left, top);
		optionsPanel.chelp:SetFont(font);
		optionsPanel.chelp:SetCheckAlignment(alignML);
		optionsPanel.chelp:SetText(spaces..WCFLangData.chelp);
		optionsPanel.chelp.CheckedChanged = function(box)
			settings.chelp = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Monsterplay --
	top = add_horizontal_line(top);
	if (not optionsPanel.mp) then	
		optionsPanel.mp = Turbine.UI.Lotro.CheckBox();
		optionsPanel.mp:SetParent(optionsPanel);
		optionsPanel.mp:SetSize(width, 16);
		optionsPanel.mp:SetPosition(left, top);
		optionsPanel.mp:SetFont(font);
		optionsPanel.mp:SetCheckAlignment(alignML);
		optionsPanel.mp:SetText(spaces..WCFLangData.mptxt);
		optionsPanel.mp.CheckedChanged = function(box)
			settings.mp = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Links --
	top = add_horizontal_line(top);
	if (not optionsPanel.links) then	
		optionsPanel.links = Turbine.UI.Lotro.CheckBox();
		optionsPanel.links:SetParent(optionsPanel);
		optionsPanel.links:SetSize(width, 16);
		optionsPanel.links:SetPosition(left, top);
		optionsPanel.links:SetFont(font);
		optionsPanel.links:SetCheckAlignment(alignML);
		optionsPanel.links:SetText(spaces..WCFLangData.links);
		optionsPanel.links.CheckedChanged = function(box)
			settings.links = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Hi and Goodby --
	top = add_horizontal_line(top);
	if (not optionsPanel.higb) then	
		optionsPanel.higb = Turbine.UI.Lotro.CheckBox();
		optionsPanel.higb:SetParent(optionsPanel);
		optionsPanel.higb:SetSize(width, 16);
		optionsPanel.higb:SetPosition(left, top);
		optionsPanel.higb:SetFont(font);
		optionsPanel.higb:SetCheckAlignment(alignML);
		optionsPanel.higb:SetText(spaces..WCFLangData.higb);
		optionsPanel.higb.CheckedChanged = function(box)
			settings.higb = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end

	-- Label Userdefined Filter
	top = add_horizontal_line(top, true);
	label = Turbine.UI.Label();
	label:SetParent(optionsPanel);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(font);
	label:SetBackColor(Turbine.UI.Color(0.2, 0.2, 1));
	label:SetForeColor(Turbine.UI.Color(0, 1, 0));
	label:SetText(WCFLangData.udflabel);
	label:SetTextAlignment(alignMC);

	-- Exclude Filter --
	top = add_horizontal_line(top, true);
	if (not optionsPanel.exfilter) then	
		optionsPanel.exfilter = Turbine.UI.Lotro.CheckBox();
		optionsPanel.exfilter:SetParent(optionsPanel);
		optionsPanel.exfilter:SetSize(width, 24);
		optionsPanel.exfilter:SetPosition(left, top);
		optionsPanel.exfilter:SetFont(font);
		optionsPanel.exfilter:SetCheckAlignment(alignML);
		optionsPanel.exfilter:SetTextAlignment(alignTL);
		optionsPanel.exfilter:SetText(spaces..WCFLangData.exftxt.."\n"..spaces..WCFLangData.fhinttxt);
		optionsPanel.exfilter.CheckedChanged = function(box)
			settings.exfilter = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end
	top = add_horizontal_line(top + 8);
	if (not optionsPanel.exfpattern) then
		optionsPanel.exfpattern = Turbine.UI.TextBox();
		optionsPanel.exfpattern:SetSelectable();
		optionsPanel.exfpattern:SetEnabled();
		optionsPanel.exfpattern:SetParent(optionsPanel);
		optionsPanel.exfpattern:SetSize(width, 18);
		optionsPanel.exfpattern:SetPosition(left, top);
		optionsPanel.exfpattern:SetMultiline(false);
		optionsPanel.exfpattern:SetFont(fontb);
		optionsPanel.exfpattern:SetTextAlignment(alignLC);
		optionsPanel.exfpattern:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1));
		optionsPanel.exfpattern:SetText("");
		optionsPanel.exfpattern.TextChanged = function(textbox)
			settings.exfpattern = textbox:GetText();
			DoCallbacks(optionsPanel, SChng);
		end
		optionsPanel.exfpattern.FocusLost = function(textbox) SaveSettings(true,false); end
	end

	-- Include Filter --
	top = add_horizontal_line(top, true);
	if (not optionsPanel.infilter) then	
		optionsPanel.infilter = Turbine.UI.Lotro.CheckBox();
		optionsPanel.infilter:SetParent(optionsPanel);
		optionsPanel.infilter:SetSize(width, 24);
		optionsPanel.infilter:SetPosition(left, top);
		optionsPanel.infilter:SetFont(font);
		optionsPanel.infilter:SetCheckAlignment(alignML);
		optionsPanel.infilter:SetTextAlignment(alignTL);
		optionsPanel.infilter:SetText(spaces..WCFLangData.inftxt.."\n"..spaces..WCFLangData.fhinttxt);
		optionsPanel.infilter.CheckedChanged = function(box)
			settings.infilter = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end
	top = add_horizontal_line(top + 8);
	if (not optionsPanel.infpattern) then
		optionsPanel.infpattern = Turbine.UI.TextBox();
		optionsPanel.infpattern:SetSelectable();
		optionsPanel.infpattern:SetEnabled();
		optionsPanel.infpattern:SetParent(optionsPanel);
		optionsPanel.infpattern:SetSize(width, 18);
		optionsPanel.infpattern:SetPosition(left, top);
		optionsPanel.infpattern:SetMultiline(false);
		optionsPanel.infpattern:SetFont(fontb);
		optionsPanel.infpattern:SetTextAlignment(alignLC);
		optionsPanel.infpattern:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1));
		optionsPanel.infpattern:SetText("");
		optionsPanel.infpattern.TextChanged = function(textbox)
			settings.infpattern = textbox:GetText();
			DoCallbacks(optionsPanel, SChng);
		end
		optionsPanel.infpattern.FocusLost = function(textbox) SaveSettings(true,false); end
	end

	-- Label for Player-Blacklist --
	top = add_horizontal_line(top, true);
	label = Turbine.UI.Label();
	label:SetParent(optionsPanel);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(Turbine.UI.Color(0.2, 0.2, 1));
	label:SetForeColor( Turbine.UI.Color(0, 1, 0));
	label:SetText(WCFLangData.pbllabel);
	label:SetTextAlignment(alignMC);

	-- Blacklist --
	top = add_horizontal_line(top, true);
	if (not optionsPanel.blstate) then	
		optionsPanel.blstate = Turbine.UI.Lotro.CheckBox();
		optionsPanel.blstate:SetParent(optionsPanel);
		optionsPanel.blstate:SetSize(width, 16);
		optionsPanel.blstate:SetPosition(left, top);
		optionsPanel.blstate:SetFont(font);
		optionsPanel.blstate:SetCheckAlignment(alignML);
		optionsPanel.blstate:SetText(spaces..WCFLangData.pbltxt);
		optionsPanel.blstate.CheckedChanged = function(box)
			settings.blstate = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end
	top = add_horizontal_line(top);
	if (not optionsPanel.blacklist) then
		optionsPanel.blacklist = Turbine.UI.TextBox();
		optionsPanel.blacklist:SetSelectable();
		optionsPanel.blacklist:SetEnabled();
		optionsPanel.blacklist:SetParent(optionsPanel);
		optionsPanel.blacklist:SetSize(width, 18);
		optionsPanel.blacklist:SetPosition(left, top);
		optionsPanel.blacklist:SetMultiline(false);
		optionsPanel.blacklist:SetFont(fontb);
		optionsPanel.blacklist:SetTextAlignment(alignLC);
		optionsPanel.blacklist:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1));
		optionsPanel.blacklist:SetText("");
		optionsPanel.blacklist.TextChanged = function(textbox)
			settings.blacklist = textbox:GetText();
			DoCallbacks(optionsPanel, SChng);
		end
		optionsPanel.blacklist.FocusLost = function(textbox) SaveSettings(true,false); end
	end

	-- Label for Player-Whitelist --
	top = add_horizontal_line(top, true);
	label = Turbine.UI.Label();
	label:SetParent(optionsPanel);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(Turbine.UI.Color(0.2, 0.2, 1));
	label:SetForeColor(Turbine.UI.Color(0, 1, 0));
	label:SetText(WCFLangData.pwllabel);
	label:SetTextAlignment(alignMC);

	-- Whitelist --
	top = add_horizontal_line(top, true);
	if (not optionsPanel.wlstate) then	
		optionsPanel.wlstate = Turbine.UI.Lotro.CheckBox();
		optionsPanel.wlstate:SetParent(optionsPanel);
		optionsPanel.wlstate:SetSize(width, 16);
		optionsPanel.wlstate:SetPosition(left, top);
		optionsPanel.wlstate:SetFont(font);
		optionsPanel.wlstate:SetCheckAlignment(alignML);
		optionsPanel.wlstate:SetText(spaces..WCFLangData.pwltxt);
		optionsPanel.wlstate.CheckedChanged = function(box)
			settings.wlstate = box:IsChecked();
			DoCallbacks(optionsPanel, SChng);
		end
	end
	top = add_horizontal_line(top);
	if (not optionsPanel.whitelist) then
		optionsPanel.whitelist = Turbine.UI.TextBox();
		optionsPanel.whitelist:SetSelectable();
		optionsPanel.whitelist:SetEnabled();
		optionsPanel.whitelist:SetParent(optionsPanel);
		optionsPanel.whitelist:SetSize(width, 18);
		optionsPanel.whitelist:SetPosition(left, top);
		optionsPanel.whitelist:SetMultiline(false);
		optionsPanel.whitelist:SetFont(fontb);
		optionsPanel.whitelist:SetTextAlignment(alignLC);
		optionsPanel.whitelist:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1));
		optionsPanel.whitelist:SetText("");
		optionsPanel.whitelist.TextChanged = function(textbox)
			settings.whitelist = textbox:GetText();
			DoCallbacks(optionsPanel, SChng);
		end
		optionsPanel.whitelist.FocusLost = function(textbox) SaveSettings(true,false); end
	end

	-- Label for pattern language --
	top = add_horizontal_line(top, true);
	label = Turbine.UI.Label();
	label:SetParent(optionsPanel);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(Turbine.UI.Color(0.2, 0.2, 1));
	label:SetForeColor(Turbine.UI.Color(0, 1, 0));
	label:SetText(WCFLangData.pllabel);
	label:SetTextAlignment(alignMC);

	-- Pattern language --
	top = add_horizontal_line(top, true);
	if (not optionsPanel.sbar) then
		optionsPanel.sbar = Turbine.UI.Lotro.ScrollBar();
		optionsPanel.sbar:SetEnabled();
		optionsPanel.sbar:SetVisible(false);
		optionsPanel.sbar:SetParent(optionsPanel);
		optionsPanel.sbar:SetWidth(10);
		optionsPanel.sbar:SetPosition(left, top);
		optionsPanel.sbar:SetHeight(20);
		optionsPanel.sbar:SetBackColor(Turbine.UI.Color(0.3, 0.3, 0.3));
		optionsPanel.sbar:SetOpacity(0.0);
		optionsPanel.sbar:SetBlendMode(0);
		optionsPanel.sbar:SetBackColorBlendMode(0);
		optionsPanel.sbar:SetValue(1);
		optionsPanel.sbar:SetMinimum(1);
		optionsPanel.sbar:SetMaximum(3);
		optionsPanel.sbar:SetOrientation(Turbine.UI.Orientation.Vertical);
		optionsPanel.sbar.ValueChanged = function(ScrollBar)
			settings.plng = ScrollBar:GetValue();
			local plng = select(settings.plng,WCFLangData.pdetxt,WCFLangData.pentxt,WCFLangData.pfrtxt)
			optionsPanel.plang:SetText(plng);
			Turbine.Shell.WriteLine(col2..WCFLangData.pchng.." => "..plng..col0);
			DoCallbacks(optionsPanel, SChng);
		end
	end
	if (not optionsPanel.plang) then
		optionsPanel.plang = Turbine.UI.Lotro.TextBox();
		optionsPanel.plang:SetParent(optionsPanel);
		optionsPanel.plang:SetSize(width - 12, 20);
		optionsPanel.plang:SetPosition(left + 12, top + 1);
		optionsPanel.plang:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
		optionsPanel.plang:SetReadOnly(true)
		optionsPanel.plang:SetTextAlignment(alignMC);
		optionsPanel.plang:SetBackColor(Turbine.UI.Color(0.3, 0.3, 0.3));
		optionsPanel.plang:SetForeColor(Turbine.UI.Color(0.4, 1, 1));
		optionsPanel.plang:SetText("");
	end

	-- Label for reset to Defaults --
	top = add_horizontal_line(top, true);
	label = Turbine.UI.Label();
	label:SetParent(optionsPanel);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor( Turbine.UI.Color(0.2, 0.2, 1));
	label:SetForeColor( Turbine.UI.Color(0, 1, 0));
	label:SetText(WCFLangData.rsetlabel);
	label:SetTextAlignment(alignMC);

	-- Reset Button --
	top = add_horizontal_line(top, true);
	local resetButton = Turbine.UI.Lotro.GoldButton();
	resetButton:SetParent(optionsPanel);
	resetButton:SetText(WCFLangData.reset);
	resetButton:SetSize(width,20);
	resetButton:SetPosition(left + 22, top + 2);
	resetButton.Click = function()
		DeepTableCopy(defaultSettings, settings);
		UpdateOptionsPanel();
		SaveSettings(true,false);
		Turbine.Shell.WriteLine(col2..WCFLangData.drtxt..col0);
		DoCallbacks(optionsPanel, SChng);
	end;

	-- Label for server-wide Defaults --
	top = add_horizontal_line(top, true);
	label = Turbine.UI.Label();
	label:SetParent(optionsPanel);
	label:SetPosition(left, top + 2);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(Turbine.UI.Color(0.2, 0.2, 1));
	label:SetForeColor(Turbine.UI.Color(0, 1, 0));
	label:SetText(WCFLangData.swdlabel);
	label:SetTextAlignment(alignMC);

	-- Load Button --
	local bwidth = (width / 2) - 4
	local bleft = left + (width / 2) + 4
	top = add_horizontal_line(top, true);
	local loadButton = Turbine.UI.Lotro.Button();
	loadButton:SetParent(optionsPanel);
	loadButton:SetText(WCFLangData.swdload);
	loadButton:SetEnabled(false);
	loadButton:SetWidth(bwidth);
	loadButton:SetPosition(left, top + 2);
	loadButton.Click = function()
		LoadSettings(true,true);
		UpdateOptionsPanel();
		--Turbine.Shell.WriteLine("<rgb=#DAA5DA>WCF-Data: "..WCFLangData.drtxt..".</rgb>");
		DoCallbacks(optionsPanel, SChng);
	end;
	-- Save Button --
	local saveButton = Turbine.UI.Lotro.Button();
	saveButton:SetParent(optionsPanel);
	saveButton:SetText(WCFLangData.swdsave);
	saveButton:SetWidth(bwidth);
	saveButton:SetPosition(bleft, top + 2);
	saveButton.Click = function()
		SaveSettings(true,true);
		UpdateOptionsPanel();
		--Turbine.Shell.WriteLine("<rgb=#DAA5DA>WCF-Data: "..WCFLangData.drtxt..".</rgb>");
		DoCallbacks(optionsPanel, SChng);
	end;
	top = top + resetButton:GetHeight();
	optionsPanel:SetSize(width + 12, top + 10);

	-- Setting the states --
	optionsPanel.invert:SetChecked(settings.invert);
    optionsPanel.sell:SetChecked(settings.sell);
	optionsPanel.give:SetChecked(settings.give);
	optionsPanel.valar:SetChecked(settings.valar);	    
    optionsPanel.buy:SetChecked(settings.buy);
	optionsPanel.search:SetChecked(settings.search);
	optionsPanel.exchange:SetChecked(settings.exchange);
	optionsPanel.group:SetChecked(settings.group);
	optionsPanel.kinship:SetChecked(settings.kinship);
	optionsPanel.craft:SetChecked(settings.craft);
	optionsPanel.chelp:SetChecked(settings.chelp);
	optionsPanel.mp:SetChecked(settings.mp);
	optionsPanel.links:SetChecked(settings.links);
	optionsPanel.higb:SetChecked(settings.higb);
	optionsPanel.exfilter:SetChecked(settings.exfilter);
	optionsPanel.exfpattern:SetText(settings.exfpattern);
	optionsPanel.infilter:SetChecked(settings.infilter);
	optionsPanel.infpattern:SetText(settings.infpattern);
	optionsPanel.blstate:SetChecked(settings.blstate);
	optionsPanel.blacklist:SetText(settings.blacklist);
	optionsPanel.wlstate:SetChecked(settings.wlstate);
	optionsPanel.whitelist:SetText(settings.whitelist);
	optionsPanel.sbar:SetValue(settings.plng);
	optionsPanel.plang:SetText(select(settings.plng,WCFLangData.pdetxt,WCFLangData.pentxt,WCFLangData.pfrtxt));
	if (sset == 1) then loadButton:SetEnabled(true); end;
end

-- Display the default settings
UpdateOptionsPanel();

-- Create the "options" tab in the plugin manager.
plugin.GetOptionsPanel = function()
	return optionsPanel;
end
