-- Standard Turbine libraries
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

--**v Detect Game Language v**
-- Check and load the LanguageData (Note: Names should be changed there)
_G.WCFLangData = {};
_G.PLang = 0;
_G.PlangTxt = "";
GLocale = Turbine.Engine.GetLanguage();
if GLocale == 268435460 then 
	--GLocale = "de";
	PLang = 1;
	import "Burgus.WCFilter.Language.Language_de";
	PLangTxt = WCFLangData.pdetxt;
elseif GLocale == 268435459 then
	--GLocale = "fr";
	PLang = 3;
	import "Burgus.WCFilter.Language.Language_fr";
	PLangTxt = WCFLangData.pfrtxt;
else
	--GLocale = "en";
	PLang = 2;
	import "Burgus.WCFilter.Language.Language_en";
	PLangTxt = WCFLangData.pentxt;
end
-- load Pattern --
_G.WCFPatData = {};
_G.WCFPatData[1] = {};
_G.WCFPatData[2] = {};
_G.WCFPatData[3] = {};
import "Burgus.WCFilter.Language.Pattern_de";
import "Burgus.WCFilter.Language.Pattern_en";
import "Burgus.WCFilter.Language.Pattern_fr";
--**^

--debug purpose
	--import "Burgus.WCFilter.Language.Language_fr";
	--PLang = 3
	--PLangTxt = WCFLangData.pfrtxt;
--debug end

local importPath = getfenv(1)._.Name;
local WCFPath = string.gsub(importPath, "%.WCFilter", "");

-- Thurallor's libraries
local commonPath = WCFPath .. ".Common";
import (commonPath .. ".Utils");
import (commonPath .. ".UI.ColorPicker");

import (importPath .. ".Settings");
import (importPath .. ".Main");
